#ifndef LINKEDSTRUCTURE_H
#define LINKEDSTRUCTURE_H
#include <vector>

#include <iostream>
#include "tools.h"
#include "color.h"
#include "Eigen/Dense"

using namespace Eigen;
using namespace std;

class Link;

class LinkedStructure
{
public:
    std::vector<Link*> mList;
    Vector2f  mTargetPosition;
    bool      mResolveTarget;
    
    MatrixXf  jacobian();
    MatrixXf  pseudoInverse();


public:
    LinkedStructure()
    {
        mTargetPosition = Vector2f::Zero(2, 1);
		mResolveTarget = false;
    }
    void     draw();
    bool     isTargetResolved();
	void     update();
    Vector2f ComputeEndEffectorPosition();
    void     GenerateTarget();
	
	inline void addLink(Link *link) { mList.push_back(link);}
};

#endif // LINKEDSTRUCTURE_H
